#include<iostream>
#include"testlib.h"

using namespace std;

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int c = atoi(argv[1]);
    if (c == -1) { // sample
        int t = atoi(argv[2]);
        cout << t << "\n";
        for (int q = 0; q < t; ++q) {
            int n = atoi(argv[q + 3]);
            vector<long long> v;
            for (int i = 0; i < n; ++i) {
                v.push_back(rnd.next(0, 20));
            }
            sort(v.begin(), v.end());
            v.erase(unique(v.begin(), v.end()), v.end());
            shuffle(v.begin(), v.end());
            cout << v.size() << '\n';
            for (int i = 0; i < v.size(); ++i) {
                if (i)
                    cout << " ";
                cout << v[i];
            }
            cout << '\n';
        }
    }
    else if (c == 0) { // all random
        cout << 1 << '\n';
        int n = rnd.next(1, 5000);
        vector<long long> v;
        for (int i = 0; i < n; ++i) {
            v.push_back(rnd.next(0ll, 1'000'000'000'000'000'000));
        }
        sort(v.begin(), v.end());
        v.erase(unique(v.begin(), v.end()), v.end());
        shuffle(v.begin(), v.end());
        cout << v.size() << '\n';
        for (int i = 0; i < v.size(); ++i) {
            if (i)
                cout << " ";
            cout << v[i];
        }
        cout << '\n';
    } else if (c == 1) { // n rand
        cout << 1 << '\n';
        int n = atoi(argv[2]);
        vector<long long> v;
        for (int i = 0; i < n; ++i) {
            v.push_back(rnd.next(0ll, 1'000'000'000'000'000'000));
        }
        sort(v.begin(), v.end());
        v.erase(unique(v.begin(), v.end()), v.end());
        shuffle(v.begin(), v.end());
        cout << v.size() << '\n';
        for (int i = 0; i < v.size(); ++i) {
            if (i)
                cout << " ";
            cout << v[i];
        }
        cout << '\n';
    } else if (c == 7) { // n smart
        cout << 1 << '\n';
        int n = atoi(argv[2]);
        vector<long long> v(1, rnd.next(1, 1'000'000));
        for (int i = 1, dif = rnd.next(1, 10'000'000) + 30000; i < n; ++i) {
            dif -= rnd.next(0, 6);
            long long now = v.back() + dif;
            v.push_back(now);
        }
        sort(v.begin(), v.end());
        v.erase(unique(v.begin(), v.end()), v.end());
        shuffle(v.begin(), v.end());
        cout << v.size() << '\n';
        for (int i = 0; i < v.size(); ++i) {
            if (i)
                cout << " ";
            cout << v[i];
        }
        cout << '\n';
    } else if (c == 2) { // multitest
        int t = atoi(argv[2]);
        cout << t << '\n';
        int maxSum = 30'000 - t;
        for (int i = 0; i < t; ++i) {
            ++maxSum;
            int n = rnd.next(1, (maxSum > 5000 ? 2500 : maxSum));
            vector<long long> v;
            for (int i = 0; i < n; ++i) {
                v.push_back(rnd.next(0ll, 1'000'000'000'000'000'000));
            }
            sort(v.begin(), v.end());
            v.erase(unique(v.begin(), v.end()), v.end());
            shuffle(v.begin(), v.end());
            cout << v.size() << '\n';
            for (int i = 0; i < v.size(); ++i) {
                if (i)
                    cout << " ";
                cout << v[i];
            }
            cout << '\n';
            maxSum -= v.size();
        }
    } else if (c == 3) { // 6 x 5000 rand
        cout << 6 << '\n';
        for (int i = 0; i < 6; ++i) {
            vector<long long> v;
            for (int i = 0; i < 5000; ++i) {
                v.push_back(rnd.next(0ll, 1'000'000'000'000'000'000));
            }
            sort(v.begin(), v.end());
            v.erase(unique(v.begin(), v.end()), v.end());
            shuffle(v.begin(), v.end());
            cout << v.size() << '\n';
            for (int i = 0; i < v.size(); ++i) {
                if (i)
                    cout << " ";
                cout << v[i];
            }
            cout << '\n';
        }
    } else if (c == 4) { //6 x 5000 to long
        cout << 6 << '\n';
        for (int i = 0; i < 6; ++i) {
            vector<long long > curr;
            long long c = 0;
            long long pre = 1;
            while (c <= (long long)(1e18) && curr.size() < 5000) {
                curr.push_back(c);
                c += pre;
                pre += 1;
            }
            while (curr.size() < 5000) {
                curr.push_back(rnd.next(0ll, 1'000'000'000'000'000'000));
            }
            sort(curr.begin(), curr.end());
            curr.erase(unique(curr.begin(), curr.end()), curr.end());
            shuffle(curr.begin(), curr.end());
            cout << curr.size() << '\n';
            for (int i = 0; i < curr.size(); ++i) {
                if (i)
                    cout << " ";
                cout << curr[i];
            }
            cout << '\n';
        }
    } else if (c == 5) { // 6 x 5000 long rand
        cout << 6 << '\n';
        for (int i = 0; i < 6; ++i) {
            int n = 5000;
            vector<long long> v(1, rnd.next(0, 1'000));
            int ans = rnd.next(0, n / 5) + n * 1 / 7;
            for (int i = 1, dif = 30000; i < ans && dif != 0; ++i, --dif) {
                long long go = dif - 3;
                dif = go;
                go += v.back();
                v.emplace_back(go);
            }
            ans = rnd.next(0, n / 5) + n * 1 / 7;
            for (int i = 1, dif = 300000; i < ans && dif != 0; ++i, --dif) {
                long long go = dif - rnd.next(0, 200);
                dif = go;
                go += v.back();
                v.emplace_back(go);
            }
            for (int i = v.size(); i < n; ++i) {
                v.emplace_back(v[0] + rnd.next(0ll, 1'000'000'000'000'000'000 - v[0]));
            }
            sort(v.begin(), v.end());
            v.erase(unique(v.begin(), v.end()), v.end());
            shuffle(v.begin(), v.end());
            cout << v.size() << '\n';
            for (int i = 0; i < v.size(); ++i) {
                if (i)
                    cout << " ";
                cout << v[i];
            }
            cout << '\n';
        }
    } else if (c == 6) { // multitest
        int t = atoi(argv[2]);
        cout << t << '\n';
        int maxSum = 30'000 - t;
        for (int i = 0; i < t; ++i) {
            ++maxSum;
            int n = rnd.next(1, (maxSum > 5000 ? 100 : maxSum));
            vector<long long> v;
            for (int i = 0; i < n; ++i) {
                v.push_back(rnd.next(0ll, 1'000'000'000'000'000'000));
            }
            sort(v.begin(), v.end());
            v.erase(unique(v.begin(), v.end()), v.end());
            shuffle(v.begin(), v.end());
            cout << v.size() << '\n';
            for (int i = 0; i < v.size(); ++i) {
                if (i)
                    cout << " ";
                cout << v[i];
            }
            cout << '\n';
            maxSum -= v.size();
        }
    }
    else if (c == 8) { // very smart
        cout << 6 << '\n';
        for (int i = 0; i < 6; ++i) {
            vector<long long> v(1, rnd.next(0ll, 500'000'000'000'000'000) + 500'000'000'000'000'000);
            int len = 4900 + rnd.next(0, 100);
            for (long long i = 1, sum = 1; v.size() < len; ++i, sum += i) {
                long long now = v.back() - sum;
                if (now < 1) break;
                v.push_back(now);
            }
            shuffle(v.begin(), v.end());
            cout << v.size() << '\n';
            for (int i = 0; i < v.size(); ++i) {
                if (i)
                    cout << " ";
                cout << v[i];
            }
            cout << '\n';
            
        }
    }
    else if (c == 9) {
        cout << 6 << '\n';
        for (int j = 0; j < 6; ++j) {
            cout << 5000 << '\n';
            for (int i = 3; i < 5000; ++i)
                cout << i * i << " ";
            cout << "1000000000000 1000000000002 1000000000003" << '\n';
        }
    }
}
