/* Maxim Deb Natkh (debnatkh@gmail.com), 2019
 */
#include <assert.h>
#include <inttypes.h>
#include <limits.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

int compare_ints(const void *p, const void *q) {
    int64_t x = *(const int64_t *)p;
    int64_t y = *(const int64_t *)q;
    if (x < y)
        return -1;
    else if (x > y)
        return 1;
    return 0;
}

enum { MAXN = 5000 };

short dp[MAXN][MAXN];
int64_t arr[MAXN];

int main() {
    int t;
    assert(scanf("%d", &t) == 1);
    while (t--) {
        int n;
        assert(scanf("%d", &n) == 1);
        for (int i = 0; i < n; ++i) {
            assert(scanf("%" SCNd64, &arr[i]) == 1);
        }
        qsort(arr, n, sizeof(int64_t), compare_ints);
        int ans = 1;
        for (int i = 0; i < n; ++i) {
            short max = SHRT_MIN;
            int pt = -1;
            for (int j = n - 1; j > i; --j) {
                dp[i][j] = (i < j) ? 2 : SHRT_MIN;
                while (pt + 1 < i &&
                       (arr[i] - arr[pt + 1]) > (arr[j] - arr[i])) {
                    ++pt;
                    max = (max < dp[pt][i] ? dp[pt][i] : max);
                }
                dp[i][j] = max + 1 < dp[i][j] ? dp[i][j] : max + 1;
                ans = (ans < dp[i][j] ? dp[i][j] : ans);
            }
        }
        printf("%d\n", ans);
    }
}
